﻿@model System.Collections.IEnumerable

@{    
    var gridSetting = ((Toyota.Common.Web.Html.Helper.DevExpress.CommonGridLookupSettings)(TempData["Grid" + TempData["GridName"]]));
    TempData["Grid" + TempData["GridName"]] = gridSetting;
    TempData["GridName"] = gridSetting.Name;
}
   
@Html.DevExpress().GridView(
    settings => {
        settings.Name = "Grid" + gridSetting.Name;
        settings.Width = gridSetting.GridProperties.Width;
        settings.Height = gridSetting.GridProperties.Height;
        settings.SettingsBehavior.AllowSelectSingleRowOnly = gridSetting.GridProperties.SettingsBehavior.AllowSelectSingleRowOnly;
        settings.SettingsBehavior.AllowSelectByRowClick = true;
        settings.Settings.ShowFilterRow = true;
        settings.Settings.ShowFilterRowMenu = true;
        settings.CallbackRouteValues = gridSetting.GridProperties.CallbackRouteValues;
          
        settings.CommandColumn.Visible = true;
        settings.CommandColumn.ShowSelectCheckbox = true; 
        settings.CommandColumn.Width = System.Web.UI.WebControls.Unit.Pixel(40);

        if (settings.SettingsBehavior.AllowSelectSingleRowOnly == false)
        {
            settings.CommandColumn.SetHeaderTemplateContent(
            c =>
            {
                Html.DevExpress().CheckBox(settingsCheckBox =>
                    {
                        settingsCheckBox.Name = "SelectAllCheckBox" + gridSetting.Name;
                        settingsCheckBox.Properties.ClientSideEvents.CheckedChanged = string.Format("function(s, e) {{ if(s.GetChecked()) {0}.SelectRows(); else {0}.UnselectRows(); }}", settings.Name);
                        settingsCheckBox.Checked = c.Grid.Selection.Count > 1;
                        settingsCheckBox.ClientVisible = !gridSetting.GridProperties.SettingsBehavior.AllowSelectSingleRowOnly;
                    }).Render();
            });
        }

        if (gridSetting.GridProperties.Columns != null)
        {
            foreach (MVCxGridViewColumn column in gridSetting.GridProperties.Columns)
            {
                column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                settings.Columns.Add(column);
            }
        }
        settings.Styles.Header.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        settings.Styles.AlternatingRow.Enabled = DefaultBoolean.True;

        settings.SettingsDetail.AllowOnlyOneMasterRowExpanded = false;
        settings.CommandColumn.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;

        settings.SettingsPager.PageSizeItemSettings.Visible = settings.SettingsPager.PageSizeItemSettings.Visible;
        settings.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100", "200" };
        settings.SettingsPager.PageSizeItemSettings.Caption = "Page size";
        settings.SettingsPager.FirstPageButton.Visible = true;
        settings.SettingsPager.LastPageButton.Visible = true;
        settings.SettingsPager.PageSize = gridSetting.GridProperties.SettingsPager.PageSize;
        settings.SettingsPager.AlwaysShowPager = gridSetting.GridProperties.SettingsPager.AlwaysShowPager;

        
        settings.Settings.VerticalScrollableHeight = 200;
        settings.Settings.VerticalScrollBarMode = ScrollBarMode.Visible;

        if (gridSetting.GridProperties.KeyFieldName != null)
        {
            settings.KeyFieldName = gridSetting.GridProperties.KeyFieldName;
            //settings.CustomJSProperties = (o, e) =>
            //{
            //    MVCxGridView grid = (MVCxGridView)o;
            //    int startIndex = grid.PageIndex * grid.SettingsPager.PageSize;
            //    int end = Math.Min(grid.VisibleRowCount, startIndex + grid.SettingsPager.PageSize);
            //    //--=== List object
            //    object[] key = new object[end - startIndex];
            //    for (int n = startIndex; n < end; n++)
            //    {
            //        key[n - startIndex] = grid.GetRowValues(n, gridSetting.GridProperties.KeyFieldName);
            //    }
            //    e.Properties["cpKey"] = key; 
            //    e.Properties["cpRowCount"] = grid.VisibleRowCount + (grid.PageIndex * grid.SettingsPager.PageSize); 
            //};
            //settings.ClientSideEvents.BeginCallback = "OnBeginCallback" + gridSetting.Name;
            //settings.ClientSideEvents.EndCallback = "OnEndCallback" + gridSetting.Name;
        }
        settings.ClientSideEvents.SelectionChanged = "SelectionChanged" + gridSetting.Name; 
        // Added by : fid.salman 25-peb-2013
        // Desc     : to perform supplier plant binding by supplier gridlookup selection. therefor supplierplant
        //            gridlookup need to able perform call back.
        if (gridSetting.GridProperties.ClientSideEvents.BeginCallback != "")
            settings.ClientSideEvents.BeginCallback = gridSetting.GridProperties.ClientSideEvents.BeginCallback; 
    }).Bind(Model).GetHtml()

    